''**********************************************************************************
''**********************************************************************************
''
''Angle between vectors using the dot product formula
''relsoft 2k8
''
''**********************************************************************************
''**********************************************************************************

const PI as single= 3.141593


type vector2d
    x       as single
    y       as single
end type


function dot(byval a as vector2d,byval  b as vector2d) as Single 
   return (a.x*b.x + a.y*b.y )
end function 

sub normalize (byref v as vector2d)
    dim leng as single
    leng = sqr(v.x * v.x + v.y * v.y )
    v.x = v.x / leng
    v.y = v.y / leng
end sub

    
function get_2dnormal ( byval x1 as single, byval y1 as single,_
                        byval x2 as single, byval y2 as single,_
                        byval s as integer) as vector2d
    
    dim normal as vector2d
    if s then
        normal.x = -(y2-y1)  'negate to get the other normal
        normal.y =  (x2-x1)  'erase negatio here if you want the other 
                                    'normal
    else
        normal.x =  (y2-y1)  'negate to get the other normal
        normal.y = -(x2-x1) 'erase negatio here if you want the other 
                                    'normal
    end if
    normalize (normal)
    return normal
    
end function

function midpoint  ( byval x1 as single, byval y1 as single,_
                     byval x2 as single, byval y2 as single) as vector2d

	dim p as vector2d
	p.x = (x2+x1)/2
	p.y = (y1+y2)/2
    
    return p
    
end function

function rad2deg(byval rad as single) as integer
    return rad*180/PI
end function

dim pnt1 as vector2d     '1st point of line
dim pnt2 as vector2d     '2nd point of line

pnt1.x = 200
pnt1.y = 300

pnt2.x = 539
pnt2.y = 300

dim as vector2d p,d,v

p.x = pnt2.x - pnt1.x 
p.y = pnt2.y - pnt1.y 
normalize(p)


screen 18,32,2,0

screenset 1, 0

do
    
    dim as integer x, y, buttons
    GETMOUSE x, y,, buttons
    
    d.x = x
    d.y = y
    
    v.x = d.x - pnt1.x
    v.y = d.y - pnt1.y
    
    dim dot_projection as single
    
    dot_projection = dot(v,p)
    
    
        
    line(0,0)-(639,479),0,bf
    
    
    
    circle(d.x,d.y),5,rgb(255,255,255)
    
    circle(pnt1.x,pnt1.y),5,rgb(255,255,255)
    circle(pnt2.x,pnt2.y),5,rgb(0,255,255)
    
    
    '' vector representation
    '' vector to project
    line(pnt1.x,pnt1.y)-(d.x,d.y),rgb(255,255,0)
    '' vector from the 2 original points
    line(pnt1.x,pnt1.y)-(pnt2.x,pnt2.y),rgb(0,255,0)
    
    
    '' draw projection
    dim nv as vector2d
    dim n_proj as vector2d
    
    
    nv.x = p.x
    nv.y = p.y
    normalize(nv)
    
    n_proj.x = nv.x*dot_projection
    n_proj.y = nv.y*dot_projection
    
    line(pnt1.x,pnt1.y)-(pnt1.x + n_proj.x,pnt1.y + n_proj.y),rgb(255,0,0)
    circle(pnt1.x + n_proj.x,pnt1.y + n_proj.y),5,rgb(0,0,255)
    
    '' draw the perpendicular
    line(d.x,d.y)-(pnt1.x + n_proj.x,pnt1.y + n_proj.y),rgb(255,0,255),,12345
    
    
    
    
    dim as single mags = sqr(v.x^2 + v.y^2)*sqr(p.x^2 + p.y^2)
    locate 1,1
    print "Interactive dot product"
    print "relsoft 2k8"
    print 
    print "Use the mouse to move."
    print
    print "Angle between the two vectors:";rad2deg(acos(dot_projection/mags))
    print "Length of projection(dot product) of v onto p:";dot_projection
    print "Sign of the dot product:"; sgn(dot_projection)
    

    screensync
    sleep 1
    screencopy 
    
            
loop until inkey<>""


end
